% Copyright (C) 2008-2010 - Consortium Scilab - Digiteo - Michael Baudin
%
% This file must be used under the terms of the 
% Creative Commons Attribution-ShareAlike 3.0 Unported License :
% http://creativecommons.org/licenses/by-sa/3.0/


\chapter{Optimization data files}

This section presents the optimization data files which can be used
to configure a specific optimization problem in Scilab.
The following is a (non-exhaustive) list of ASCII file formats often used in optimization 
softwares :
\begin{itemize}
\item SIF : Standard Input Format \cite{SIFreferenceURL,Murtagh1981},
\item GAMS : General Algebraic Modeling System \cite{GAMSwikipedia,GAMS.com}
\item AMPL : A Mathematical Programming Language \cite{AMPL.com,AMPLwikipedia}
\item MPS : Mathematical Programming System \cite{MPS.lpsolve,MPS.wikipedia}
\end{itemize}
but other file formats appeared in recent years, such as the XML-based 
file format OSiL \cite{optimizationservices.org,coinor.org.osil,FourerMa2008}.

The following sections describe Scilab tools to manage optimization data files. 

\section{MPS files and the Quapro toolbox}

The Quapro toolbox implements the \scifun{readmps} function, which reads 
a file containing description of an LP problem given in MPS format and returns a tlist describing the 
optimization problem.
It is an interface with the program  rdmps1.f   of hopdm (J. Gondzio). For a description of the variables, see the file rdmps1.f.
MPS format is a standard ASCII medium for LP codes. MPS format is described in more detail in Murtagh's book \cite{Murtagh1981}.

\section{SIF files and the CUTEr toolbox}

The SIF file format can be processed with the CUTEr Scilab toolbox. 
Given a SIF \cite{SIFreferenceURL} file 
the function \scifun{sifdecode} generates associated Fortran routines RANGE.f, EXTER.f, ELFUN.f, GROUP.f 
and if automatic differentiation is required ELFUND.f, GROUPD.f, EXTERA.f. 
An associated data file named OUTSDIF.d and an Output messages file OUTMESS are also generated. 
All these files are created in the directory whose path is given in Pathout. 
The \scifun{sifdecode} function is based on the Sifdec code \cite{SIFdecoder}. 
More precisely it results of an interface of SDLANC Fortran procedure.

